#!/usr/bin/perl -w

use strict;
require Tk;
use Tk;
use LWP 5.64;
use HTTP::Cookies; 
use HTTP::Request::Common;

my $main = MainWindow->new;
$main->title('Vkontakt Album Wipe GUI Beta');
$main->minsize(qw(300 270));
$main->configure (-background=>'grey');

$main->Label(-text => 'login (email)',-background=>'grey')->pack;
my $loginform = $main->Entry(	-width => 20, -foreground => 'blue')->pack;
$loginform->insert('end',"mail");

$main->Label(-text => 'password',-background=>'grey')->pack;
my $passform = $main->Entry(	-width => 20, -foreground => 'blue')->pack;
$passform->insert('end',"pass");

$main->Label(-text => 'Target group id.',-background=>'grey')->pack;
my $groupform = $main->Entry(	-width => 40, -foreground => 'blue')->pack;
$groupform->insert('end',"0");

$main->Label(-text => 'YOUR userid.',-background=>'grey')->pack;
my $userform = $main->Entry(	-width => 40, -foreground => 'blue')->pack;
$userform->insert('end',"0");

$main->Label(-text => 'Image dir. Put nigras here.',-background=>'grey')->pack;
my $img_dirform = $main->Entry(-width => 20, -foreground => 'blue')->pack;
$img_dirform->insert('end',"./nigra");

$main->Label(-text => 'Proxy Server (If left blank - no proxy)',-background=>'grey')->pack;
my $proxyform = $main->Entry(-width => 20, -foreground => 'blue')->pack;
$proxyform->insert('end','http://127.0.0.1:8118');
$main->Button(	-text => 'Holy wipe!',
	      	-width => 40,
		-height => 5,
		-background => 'orange',
		-foreground => 'red',
           	-command => \&wipe)->pack(-pady => 10);
MainLoop();

sub wipe
{
my $login_mail=$loginform->get;
my $login_pass=$passform->get;
my $userid=$userform->get;
my $groupid=$groupform->get;
my $img_dir=$img_dirform->get;
my $use_proxy=$proxyform->get;

my @images='';
my $img_name='';
print "You entered following data:\nlogin=$login_mail\npassword=$login_pass\nGID=$groupid\nUID=$userid\nImage directory=$img_dir\n";
$main->destroy;
	
	my $album_id = -1; 
	
	my $useragent = 'Mozilla/5.0 (Windows; U; Windows NT 5.1;) Firefox/2.0.0.0';
	
	# ONE dir per album. More dirs, more new albums
	my @img_dirs = ("$img_dir"); 
	
	# new albums names (will use random)
	my @album_names = ('NIGRAS1','NIGRAS2','NIGRAS3','NIGRAS4','NIGRAS5','NIGRAS6');
	
	my $url_login = 'http://vkontakte.ru/login.php';
	my $url_photos = 'http://vkontakte.ru/photos.php';
	my $url_upload = 'http://cs218.vkontakte.ru/upload.php';
	
	my $ua = LWP::UserAgent->new(keep_alive => 1, requests_redirectable => [ 'POST' ]);
	$ua->proxy('http', $use_proxy) if $use_proxy;
	$ua->agent($useragent);
	$ua->cookie_jar({});
	
	print 'Login... ';
	my $response = $ua->post($url_login, 
		[	'email' => $login_mail, 
			'pass' => $login_pass, 
		]);
	die 'Login error -- ', $response->status_line
		unless $response->is_success or $response->code == 302;
	print "Success.\n";
	srand (time ^ $$);
	
L0:	foreach $img_dir (@img_dirs) {
		# read dir with content
		opendir(DIR,$img_dir) or do { warn "opendir error!"; next L0; };
		@images= readdir(DIR);
		closedir(DIR);

		# start process if we want to post in the existing album
		my $aid = $album_id;
		goto L1 if $album_id;
		
		# create new album
		my $album_name = $album_names[int(rand($#album_names + 1))];
		print "Create album ($album_name)... ";
		$aid = new_album($ua,$url_photos,$album_name,$album_name,$groupid);

	L1:	foreach $img_name (@images) {
			next if(($img_name eq ".") || ($img_name eq ".."));
			if ($album_id < 0) {
				print "Create album ($img_name)... ";
				$aid = new_album($ua,$url_photos,$img_name,$img_name,$groupid);
				next if ($aid<0);
			}
			print "IMAGE: $img_dir/$img_name\n";
			# get server URL
			$response = $ua->get("$url_photos\?act=add\&id=$aid");
			do { warn "Get images server URL error -- ", $response->status_line; next L1; }
				unless $response->is_success or $response->code == 302;
			$_ = $response->content =~ m|name\s*=\s*\"upload\"\s*action\s*=\s*\"([^\"]+)\"|ig;
			$url_upload = $1;
			
			# get hash values
			$_ = $response->content;
			my ($hash) = /name=\"hash\" value=\"(\w+)\" /;
			my ($rhash) = /name=\"rhash\" value=\"(\w+)\" /;
			
			# send image
			my $req = POST $url_upload, Content_Type => 'multipart/form-data',
				Content      => [
					act => 'do_add',
					id => $aid,
					aid => $aid,
					gid => $groupid,
					mid => $userid,
					hash => $hash,
					rhash => $rhash,
					file1 =>  [ "$img_dir/$img_name" ]
				];
			$response = $ua->request($req);	
			do { warn "Upload error -- ", $response->status_line; next L1; }
				unless $response->is_success or $response->code == 302;	
			$_ = $response->content;
			
			# now set newly loaded image as a cover of the album
			$response = $ua->get("$url_photos\?act=editphotos\&id=$aid\&u=1");
			$_ = $response->content;

			@_ = /name=\"cover\" value=\"-(\w+)\"/gm;
			my $img_id = "-$_[$#_]";
			my $img_no = $#_ + 1;
			
			$response = $ua->post("$url_photos\?act=editphotos\&id=$aid\&u=1", 
				[	'act' => 'do_editphotos', 
					'id' => $aid, 
					"cover" => $img_id,
				]);
			do { warn " Cover setting error -- ", $response->status_line; next L1; }
				unless $response->is_success or $response->code == 302;
			sleep 1;
		}
	}
	
	sub new_album {	
		# create new album
		my ($agent,$url,$album_name,$album_desc,$gid) = @_;
		
		print "Create album ($album_name)... ";
		my $response = $agent->post( $url,
			[ 'act' => 'create', 'gid' => $gid,'name' => $album_name, 'desc' => $album_desc, 'visible' => '1', ]
		);
		do { warn " Create new album error -- ", $response->status_line; return -1; }
			unless $response->is_success or $response->code == 302;
		print "Success.\n";
		
		$response = $ua->get("$url\?gid=$gid");
		$_ = $response->content;
		@_ = /\"photos.php\?act=album&id=(\d+)\"/gm;
		# return album ID
		return $_[$#_];
	}
}
